<template>
  <div class="base-image-container">
    <div :style="{position: 'relative', height, width}">
      <img
        :src="src"
        :style="{
          'max-height': height,
          'max-width': width,
          'z-index': 1,
          position: 'absolute',
          ...imageStyle
        }"
        class="w-100"
      >
      <img
        :style="{position: 'absolute', 'z-index': 0}"
        class="w-100"
        src="../assets/not-found.svg"
      >
    </div>
  </div>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';

export default Vue.extend({
  props: {
    height: {
      type: String,
      default: 'auto',
    },
    flipX: {
      type: Boolean,
      default: false,
    },
    flipY: {
      type: Boolean,
      default: false,
    },
    inverse: {
      type: Boolean,
      default: false,
    },
    src: {
      type: String,
      required: true,
    } as PropOptions<string>,
    width: {
      type: String,
      default: 'auto',
    },
  },

  computed: {
    imageStyle() {
      const style: {[key: string]: string} = {};
      if (this.inverse) {
        style.filter = 'invert(100%)';
      }
      if (this.flipX) {
        style.transform = 'scaleX(-1)';
      }
      if (this.flipY) {
        style.transform = 'scaleY(-1)';
      }
      return style;
    },
  },
});
</script>

<style scoped lang="scss">
@import "../styles/custom.scss";
.base-image-container {
  outline: 1px solid $dark;
}

</style>
